with Vector_Pkg, Ada.Text_IO, Ada.Integer_Text_IO;
use Vector_Pkg, Ada.Text_IO, Ada.Integer_Text_IO;
procedure Vector_Test is
   N : Integer;
begin
   Put("Size of vector to be processed: ");
   Get(N);
   Skip_Line; -- Flush end-of-line
   declare
      V : Vector(1..N);
   begin
      Put_Line("Initialize...");
      Init(V);     -- Prompts the user for data
      Put_Line("Sort...");
      Sort(V);     -- Sorts the Vector
      Display(V);  -- Displays the result
      Put_Line("Multiply by 2...");
      V := 2 * V;  -- Multiplies each element by 2
      Display(V);  -- Displays the result
   end;
end Vector_Test;
