with Int_List_Pkg; use Int_List_Pkg;
with Ada.Text_IO; use Ada.Text_IO;
procedure Int_List_Test is
  List, Ref1, Ref2  : Node_Ref; 
  Line              : String(1..80); 
  Last, N           : Integer;
  Found             : Boolean;
  function Are_Clones(Ref1, Ref2 : Node_ref) return Boolean is
  begin
    if ref1=null and ref2=null then
       return True;
    elsif ref1/=null and ref2/=null then
       return ref1/=ref2 and ref1.all.Data=ref2.all.data and
              Are_Clones(Ref1.all.Next, ref2.all.Next);
    else 
       return false;
    end if;
 end Are_Clones;
       
       
begin
  loop
    Put("Type an integer, or an empty line to quit: ");
    Get_Line(Line, Last);
    exit when Last = 0;
    N := Integer'Value( Line(1..Last) );
    List := new Node'( N, List ); -- Prepend
  end loop;
  Put_Line("Displaying the list...");
  Display(List);
  
  Put_Line("Testing the Locate function...");
  loop
    Put("Type an integer to look up, or an empty line to quit: ");
    Get_Line(Line, Last);
    exit when Last = 0;
    N := Integer'Value( Line(1..Last) );
    Found := Locate(List,N) /= null;
    Put_Line("Found " & Integer'Image(N) & ": " & Boolean'Image(Found) );
  end loop;

  Put_Line("Testing the clone function...");
  Ref1 := List;
  Ref2 := Clone(List);
  Put_Line("Contents of cloned list...");
  Display(Ref2);
  if Are_Clones(Ref1, ref2) then
     Put_Line("Clone succeeded");
  else
     Put_Line("Clone failed");
  end if;
  
end Int_List_Test;
