with Ada.Text_IO; use Ada.Text_IO;
package body Person_Pkg is
   procedure Put( Item : in Person ) is
   begin
      Put_Line("Tag: " & Person_Tag'Image(Item.Tag));
      Put_Line("Name: " & Item.Name);
      case Item.Tag is
         when Student =>
            Put_Line("GPA: " & Float'Image(Item.GPA));
            Put_Line("Year: " & Integer'Image(Item.Year));
         when Faculty =>
            Put_Line("Pubs: " & Integer'Image(Item.Pubs));
      end case;
   end Put;
            
   procedure Get( Item : out Person ) is
      Line : String(1..80) := (others => ' ');
      Last : Natural;
   begin
      -- Tag is already set
      Put("Name: ");
      Get_Line(Line, Last);
      Item.Name := Line(1..10);
      case Item.Tag is
         when Student =>
            Put("GPA: ");
            Get_Line(Line, Last);
            Item.GPA := Float'Value(Line(1..Last));
            Put("Year: ");
            Get_Line(Line, Last);
            Item.Year := Integer'Value(Line(1..Last));
         when Faculty =>
            Put("Pubs: ");
            Get_Line(Line, Last);
            Item.Pubs := Integer'Value(Line(1..Last));
      end case;      
   end Get;
end Person_Pkg;
