package Person_Pkg is
   type Person_Tag is (Student, Faculty);
   type Person(Tag : Person_Tag) is
      record
         Name : String(1..10);
         case Tag is
            when Student =>
               GPA  : Float range 0.0 .. 4.0;
               Year : Integer range 1..4;
            when Faculty =>
               Pubs : Integer;
         end case;
      end record;
   procedure Put( Item : in Person );
   procedure Get( Item : out Person );
end Person_Pkg;
