with Day_Pkg; use Day_Pkg;
with Ada.Text_IO; use Ada.Text_IO;
procedure Day_Test is
   D1, D2 : Day;
   N      : Integer;
   Line   : String(1..80);
   Last   : Natural;
begin
   Put_Line("When prompted for a Day value, enter one of: ");
   for D in Day loop
      Put(Day'Image(D) & "  ");
   end loop;
   New_Line;
   Put_Line("Starting tests for Day+Integer...");
   loop
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;
      D1 := Day'Value(Line(1..Last));
      Put("Type an integer: ");
      Get_Line(Line, Last);
      N := Integer'Value(Line(1..Last));
      D2 := D1 + N;  -- The code being tested
      Put_Line("Result is " & Day'Image(D2));
   end loop;
   Put_Line("Starting tests for Day-Day...");
   loop
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;
      D1 := Day'Value(Line(1..Last));
      Put("Type a Day (empty line to exit): ");
      Get_Line(Line, Last);
      exit when Last=0;
      D2 := Day'Value(Line(1..Last));
      N := D1 - D2;  -- The code being tested
      Put_Line(Day'Image(D1) & " - " & Day'Image(D2) & " = " & 
               Integer'Image(N));
   end loop;
end Day_Test;