with Employee_Pkg; use Employee_Pkg;
with Ada.Text_IO;
procedure Employee_Test is
   Role  : Employee_Role; 
   Line  : String(1..80); 
   Index : Natural;
   use Ada.Text_IO;
begin
   loop
      Put("Role (Engineer or Manager, empty line to quit): ");
      Get_Line(Line, Index);
      exit when Index=0;
      Role := Employee_Role'Value(Line(1..Index));
      declare
         Someone : Employee(Role);
      begin
         Get(Someone); -- Initialize based on Tag
         Put_Line("Processing...");
         -- Processing:
         Someone.Salary := 2 * Someone.Salary;
         case Someone.Role is  -- Process the data
            when Engineer => 
               Someone.Cubicle_Size := Someone.Cubicle_Size + 100;
            when Manager => 
               Someone.Is_Pointy_Haired := not Someone.Is_Pointy_Haired; 
         end case;
         -- 
         Put(Someone);  -- Display the fields
      end;
   end loop;
end Employee_Test;
