with Ada.Text_IO; use Ada.text_IO;
with System.Storage_Elements; use System.storage_Elements;
package body Int_List_Pkg is
  function Sum( List : Node_Ref ) return Integer is
    Result : Integer  := 0;
    Ref    : Node_Ref := List;
  begin
    while Ref /= null loop
      Result := Result + Ref.all.Data; 
      Ref    := Ref.all.Next;
    end loop;
    return Result;
  end Sum;
  
  procedure Display( List : Node_ref ) is
     Ref : Node_ref := List;
  begin
     while Ref /= null loop
        Put("Node at address:" & 
            Integer_Address'Image( To_Integer( Ref.all'Address )) &
            ",  ");
        Put_Line("Data:" & Integer'Image(Ref.all.Data) );
        Ref := ref.all.Next;
     end loop;
  end Display;
      
  function Locate( List : Node_Ref; Item : Integer ) return Node_Ref is
  begin
     if List=null then
        return null;
     elsif List.Data = Item then
        return List;
     else 
        return Locate( List.Next, Item );
     end if;
  end Locate;
  
  function Clone( List : Node_Ref ) return Node_Ref is
     Ref : Node_Ref;
  begin
    if List = null then 
      return null;
    else
       Ref := new Node'(List.Data, List.Next);
       Ref.Next := Clone(List.Next);
       return Ref;
    end if;
  end Clone;
end Int_List_Pkg;
       
