with Vector_Pkg, Array_Handling, Ada.Text_IO, Ada.Integer_Text_IO;
use Vector_Pkg, Array_Handling, Ada.Text_IO, Ada.Integer_Text_IO;
procedure Array_Test is
   N, Num_Shuffles : Integer;
begin
   Put("Size of array to be shuffled: ");
   Get(N);
   declare
      A : Array_Type(2..N+1); -- Sneaky, to test array handling 
      Line : String(1..80);
      Last : Natural;
   begin
      Init(Vector(A));     -- Prompts the user for data
      Display(Vector(A));  -- Displays the result
      Put("Number of times to shuffle: ");
      Get(Num_Shuffles);
      Skip_Line;
      for I in 1..Num_Shuffles loop
         Shuffle(A);          -- Shuffles the array
         Display(Vector(A));  -- Displays the result
         Put("Type 'Enter' to continue");
         Get_Line(Line, Last);
      end loop;
   end;
end Array_Test;
