with Integrate_Pkg, Integrate_Functions_Pkg;
use Integrate_Pkg, Integrate_Functions_Pkg;
with Ada.Float_Text_IO, Ada.Text_IO; 
use Ada.Float_Text_IO, Ada.Text_IO;
procedure Integrate_Test is
  N : Integer;
  X_Low, X_High, Result1, Result2 : Float;
  Line : String(1..80);
  Last : Natural;
begin
  Put_Line("Tests for integrating X**2 and e**X");
  loop
    Put("Number of intervals (0 to exit): ");
    Get_Line(Line, Last);
    N := Integer'Value(Line(1..Last));
    exit when N=0;
    Put("Low bound: ");
    Get_Line(Line, Last);
    X_Low := Float'Value(Line(1..Last));
    Put("High bound: ");
    Get_Line(Line, Last);
    X_High := Float'Value(Line(1..Last));
    Result1 := Integrate(Square'Access, X_Low, X_High, N);
    Put("Result of integrating X**2 is: ");
    Put(Result1, Aft => 3, Exp => 0);
    New_Line;
    Result2 := Integrate(Exp'Access, X_Low, X_High, N);
    Put("Result of integrating e**X is: ");
    Put(Result2, Aft => 3, Exp => 0);
    New_Line;
  end loop;
end Integrate_Test;  
    
  
