with Ada.Exceptions; use Ada.Exceptions;
with Ada.Text_IO; use Ada.Text_IO;
procedure Exception_Test is
   X : array (1..5) of Integer := (others => 0);
begin
   X(6) := 10;
exception
   when E1 : Constraint_Error =>  -- Implicitly declares E : Exception_Occurrence
      Put_Line( Exception_Information(E1) );
      begin
         X(7) := 0;
      exception
         when E2 : others =>
            Put_Line( Exception_Information(E1) );
            Put_Line( Exception_Information(E2) );
      end;
end Exception_Test;
