with Ada.Text_IO; use Ada.Text_IO;
with Ada.Exceptions; use Ada.Exceptions;
procedure Exceptions_Example is
  My_Exception : exception;
begin
  declare
    N : Natural;
  begin
    N := -1;
  exception
    when E : others =>
      Put_Line("Name: " & Exception_Name(E));
      Put_Line("Message: " & Exception_Message(E));
      Put_Line("Information: " & Exception_Information(E));
  end;
  begin
    Put_Line("Raising My_Exception...");
    Raise_Exception( My_Exception'Identity, "Just raised My_Exception");
  exception
    when E : My_Exception =>
      Put_Line("Name: " & Exception_Name(E));
      Put_Line("Message: " & Exception_Message(E));
      Put_Line("Information: " & Exception_Information(E));
  end;
end Exceptions_Example;
