with Ada.Text_IO; use Ada.Text_IO;
with Ada.Exceptions; use Ada.Exceptions;
procedure Exceptions_Example2 is
  EO           : Exception_Occurrence;
begin
  declare
    Local_Exception : exception;
  begin
    raise Local_Exception;
  exception
    when E : others =>
      Put_Line("Name: " & Exception_Name(E));
      Put_Line("Message: " & Exception_Message(E));
      Put_Line("Information: " & Exception_Information(E));
      Save_Occurrence(EO, E);
  end;
  begin
    Put_Line("Re-Raising the exception occurrence...");
    Reraise_Occurrence( EO );
  exception
    when E : others =>
      Put_Line("Name: " & Exception_Name(E));
      Put_Line("Message: " & Exception_Message(E));
      Put_Line("Information: " & Exception_Information(E));
  end;
end Exceptions_Example2;
