procedure Overloading_Example is
  procedure P(X : Integer) is begin null; end P;     -- (1)
--  procedure P(Y : out Integer) is begin null; end P; -- (2) illegal
  procedure P is begin null; end P;                  -- (3) overloads (1)
begin
  declare
    procedure P(Y : Integer) is begin null; end P;      -- (4) hides (1)
    procedure P(Z : Long_Integer) is begin null; end P; -- (5) overloads
    I : Integer := 0;
  begin
    P(I);             -- unambiguous (4)
    P(10);            -- ambiguous (4, 5)
    P(X => 0);        -- Illegal since (1) is hidden
    P(Z => 10);       -- unambiguous (5)
    P(Integer'(10));  -- unambiguous (4)
    Overloading_Example.P(10);      -- unambiguous (1)
  end;
end Overloading_Example;
