with Parity_Pkg; use Parity_Pkg;
with Ada.Text_IO; use Ada.Text_IO;
procedure Test_Parity is
   S  : String(1..80);
   SS : Symbol_String(1..80) := (1..80 => '0');
   N  : Natural;
   B  : Boolean;
begin
   Put_Line("Type the input string for the Odd_Parity function.");
   Put_Line("It should consist solely of '0' and '1' characters.");
   Put_Line("Any other character is treated as '0'.");
   Put(": ");
   Get_Line(S, N);
   for I in 1..N loop
      if S(I) in Symbol then
         SS(I) := S(I);
      end if;
      -- If S(I) is not '0' or '1' then SS(I) is not overwritten
      -- It retains its initialization, which is '0'
   end loop;
   B := Odd_Parity( SS(1..N) );
   Put_Line("Odd parity: " & Boolean'Image(B));
end Test_Parity;
