package body Day_Pkg is
--   type Day is (Sun, Mon, Tue, Wed, Thu, Fri, Sat);
   function "+"(D : Day; N : Integer) return Day is
      N_Mod7 : constant Integer := N mod 7;  -- Avoids overflow
      Result : Day;
   begin
      Result := Day'Val( (Day'Pos(D) + N_Mod7 ) mod 7 );
      return Result;
   end "+";
   
   function "-"(D1, D2 : Day) return Integer is
   begin
      return (Day'Pos(D1)-Day'Pos(D2)) mod 7;
   end "-";
end Day_Pkg;

