pragma Assertion_Policy(Check);
package Vector_Pkg_3 is
  type Vector is array (Positive range <>) of Float;

  procedure Init( V : out Vector );

  procedure Display( V : in Vector );

  procedure Sort(V : in out Vector);

  function "*"(L : Integer; R : Vector) return Vector;

  function "*"(L, R : Vector) return Float
  with  Pre => L'Length=R'Length;
end Vector_Pkg_3;
