with Vector_Pkg_2, Ada.Text_Io, Ada.Integer_Text_Io;
use Vector_Pkg_2, Ada.Text_Io, Ada.Integer_Text_Io;
with Ada.Exceptions;
use Ada.Exceptions;
procedure Vector_Test_2 is 
   N1,  
   N2      : Integer;  
   Dotprod : Float;  
begin
   loop
      Put("Size of 1st vector to be processed (0 to terminate): "
         );
      Get(N1);
      Skip_Line; -- Flush end-of-line
      exit when N1=0;
      Put("Size of 2nd vector to be processed: ");
      Get(N2);
      declare
         V1 : Vector (1 .. N1);  
         V2 : Vector (1 .. N2);  
      begin
         Put_Line("Initialize first vector...");
         Init(V1);     -- Prompts the user for data
         Put_Line("Initialize second vector...");
         Init(V2);     -- Prompts the user for data
         begin
            Dotprod := V1 * V2;
            Put_Line("Dot Product: " & Float'Image(Dotprod) );
         exception
            when E :Parameter_Length_Error => 
             Put_Line (Ada.Exceptions.Exception_Information (E));
         end;
      end;
   end loop;
end Vector_Test_2;
