with Mutant_String_Pkg; use Mutant_String_Pkg;
package Course_Pkg is
   type Student is
      record
         Name  : Mutant_String;
         Grade : Integer range 0..100;
      end record;
      
   type Student_Array is array(Positive range <>) of Student;
   
   type Course(Max_Students : Natural) is
      record
         Teacher_Name : Mutant_String;
         Num_Students : Natural;
         Students     : Student_Array(1..Max_Students);
      end record;
end Course_Pkg;
