with Ada.Text_IO; use Ada.Text_IO;
package body Employee_Pkg is
--   type Employee_Role is (Manager, Engineer);
--   type Employee(Role : Employee_Role) is
--      record
--         SSN : String(1..9);
--         Salary : Positive;
--         case Role is
--            when Engineer =>
--               Cubicle_Size : Integer;
--            when Manager =>
--               Is_Pointy_Haired : Boolean;
--         end case;
--      end record;
   procedure Put( Item : in Employee ) is
   begin
      Put_Line("Role: " & Employee_Role'Image(Item.Role));
      Put_Line("SSN: " & Item.SSN);
      Put_Line("Salary: " & Integer'Image(Item.Salary));
      case Item.Role is
         when Engineer =>
            Put_Line("Cubicle Size: " & Integer'Image(Item.Cubicle_Size));
         when Manager =>
            Put_Line("Is_Pointy_Haired: " & Boolean'Image(Item.Is_Pointy_Haired));
      end case;
   end Put;
            
   procedure Get( Item : out Employee ) is
      Line : String(1..80) := (others => ' ');
      Last : Natural;
   begin
      -- Role is already set
      Put("SSN: ");
      Get_Line(Line, Last);
      Item.SSN := Line(1..9);
      Put("Salary: ");
      Get_Line(Line, Last);
      Item.Salary := Integer'Value(Line(1..Last));
      case Item.Role is
         when Engineer =>
            Put("Cubicle size: ");
            Get_Line(Line, Last);
            Item.Cubicle_Size := Integer'Value(Line(1..Last));
         when Manager =>
            Put("Pointy haired? (true or false): ");
            Get_Line(Line, Last);
            Item.Is_Pointy_Haired := Boolean'Value(Line(1..Last));
      end case;      
   end Get;
end Employee_Pkg;
