package Employee_Pkg is
   type Employee_Role is (Manager, Engineer, Administrative);
   type Employee(Role : Employee_Role) is
      record
         SSN : String(1..9);
         Salary : Positive;
         case Role is
            when Engineer =>
               Cubicle_Size : Integer;
            when Manager =>
               Is_Pointy_Haired : Boolean;
            when Administrative =>
               Helpfulness : Integer range -10..0;
         end case;
      end record;
   procedure Put( Item : in Employee );
   procedure Get( Item : out Employee );
end Employee_Pkg;
