package body Int_Stack_Pkg is
--   subtype Element_Type is Integer);
--   Overflow, Underflow : exception;
--   type Element_Array is array(Positive range <>) of Element_Type;
--   type Stack(Max_Size : Natural) is 
--      record
--         Current_Size : Natural := 0;
--         Data         : Element_Array(1..Max_Size);
--      end record;

   procedure Push(S : in out Stack; E : in Element_Type) is separate;
   
   procedure Pop(S : in out Stack; E : out Element_Type) is separate;

   function Top( S : Stack ) return Element_Type is separate;
   
   function Current_Size(S : Stack) return Natural is separate;
end Int_Stack_Pkg;


   