with Vector_Pkg, Generic_Array_Handling, Ada.Text_IO, Ada.Integer_Text_IO;
use Vector_Pkg, Ada.Text_IO, Ada.Integer_Text_IO;
procedure Array_Test is
   package Array_Handling is new Generic_Array_Handling(Float, Vector);
   use Array_Handling;
   N, Num_Shuffles : Integer;
begin
   Put("Size of array to be shuffled: ");
   Get(N);
   declare
      A : Vector(2..N+1); -- Sneaky, to test array handling 
      Line : String(1..80);
      Last : Natural;
   begin
      Init(A);     -- Prompts the user for data
      Display(A);  -- Displays the result
      Put("Number of times to shuffle: ");
      Get(Num_Shuffles);
      Skip_Line;
      for I in 1..Num_Shuffles loop
         Shuffle(A);          -- Shuffles the array
         Display(A);  -- Displays the result
         Put("Type 'Enter' to continue");
         Get_Line(Line, Last);
      end loop;
   end;
end Array_Test;
