with Random_Numbers; use Random_Numbers;
package body Generic_Array_Handling is
  procedure Shuffle( Data : in out Array_Type ) is
     N    : Integer range Data'Range;
     Temp : Element_Type;
  begin
    if Data'Length=0 then
       return;
    end if;
    for I in Data'Range loop
      N := I-1+Random(Data'Last-I+1);
      -- Index in the range I .. Data'Last
      -- Swap the elements at Data(I) and Data(N) 
      Temp    := Data(I);
      Data(I) := Data(N);
      Data(N) := Temp;
    end loop;
  end Shuffle;
end Generic_Array_Handling;
